質問をすることでしか得られない、回答やアドバイスがある。

15分調べてもわからないことは、質問しよう!

ただいまの
回答率

90.45%

  • Python 3.x

    10346questions

    Python 3はPythonプログラミング言語の最新バージョンであり、2008年12月3日にリリースされました。

サーバーから code 200(成功)以外の時でもwhile 文を止めずに再処理したい

解決済

回答 1

投稿

  • 評価
  • クリップ 0
  • VIEW 447

ramble

score 1

 前提・実現したいこと

サーバーから code 200(成功)以外の時でもwhile 文を止めずに再処理したい
Windows10 Pythonで仮想通貨取引所のZaifのAPIを使って現在情報を取得しようとしています。
通常は問題なく動作するのですが、サーバーから502、504のコードが帰ってくるとプログラムが終了してしまいます。
サーバーからのコードが200以外のエラーコードが返ってきても終了せずに、プログラムを続行させたいのですがどのようにコードを書けばよいのでしょうか。

プログラム起動中に以下のエラーメッセージが発生しました。

 発生している問題・エラーメッセージ

Traceback (most recent call last):
File "C:\zaif\zaiftest02.py", line 33, in <module>
funds_jpy = zaif_trade.get_info2()['funds']['jpy']
File "C:\Users\...\AppData\Local\Programs\Python\Python36-32\lib\site-packages\zaifapi\exchange_api\trade.py", line 70, in get_info2
return self._execute_api(method_name())
File "C:\Users\...\AppData\Local\Programs\Python\Python36-32\lib\site-packages\zaifapi\exchange_api\trade.py", line 33, in _execute_api
res = get_response(url, params, header)
File "C:\Users\....\AppData\Local\Programs\Python\Python36-32\lib\site-packages\zaifapi\api_common\response.py", line 9, in get_response
raise ZaifServerException('return status code is {}'.format(response.status_code))
zaifapi.api_error.ZaifServerException: return status code is 502

エラーメッセージ


Traceback (most recent call last):

zaifapi.api_error.ZaifServerException: return status code is 502

 該当のソースコード

Python 3.6.4
ソースコード


import json
import time

from zaifapi import ZaifPublicApi
from zaifapi import ZaifTradeApi
from decimal import (Decimal)

zaif_keys_json = open('config/zaifkeys.json', 'r' ,encoding="utf-8_sig")
zaif_keys = json.load(zaif_keys_json)

KEY = zaif_keys["key"]
SECRET = zaif_keys["secret"]

if name=='main':

 get environ ver

zaif_public = ZaifPublicApi()
zaif_trade = ZaifTradeApi(KEY,SECRET)

CANCEL_FLUG = False

Last_trade_price = int(zaif_public.last_price('btc_jpy')["last_price"])

while (True):
import datetime
today = datetime.date.today()
todaydetail = datetime.datetime.today()
print("■ 現在の情報です:")
print(todaydetail.strftime("%Y/%m/%d %H:%M:%S"))
funds_btc = zaif_trade.get_info2()['funds']['btc']
funds_jpy = zaif_trade.get_info2()['funds']['jpy']
last_price = int(zaif_public.last_price('btc_jpy')["last_price"])
print("市場取引価格:"+str(last_price))
print("btc資産:"+str(funds_btc))
print("jpy資産:"+str(funds_jpy))
print("最終取引価格:"+str(Last_trade_price))
print(" ")

time.sleep(5)

 試したこと

ここに問題に対して試したことを記載してください。
通常は下記のように表示されます。(コマンドプロンプトでプログラムを起動)
c:\zaif>zaiftest02.py
■ 現在の情報です:
2018/02/26 17:42:52
市場取引価格:1006135
btc資産:0.03865504
jpy資産:149.18181063
最終取引価格:1006135

不規則で前期の502,504のサーバーからのエラーコードが返ってくるため、強制終了されてしまいます。
たぶんZaifのサーバーが大量のユーザーからのアクセスに稼働環境が追い付いていないのではないかと思っています。
502、504のコードが返ってきてもプログラムをwhileの頭からやり直したいのです。
サーバーからのエラーが返ってきても、何度でもリトライするプログラムにしたいと考えております。

 補足情報(FW/ツールのバージョンなど)

ここにより詳細な情報を記載してください。

  • 気になる質問をクリップする

    クリップした質問は、後からいつでもマイページで確認できます。

    またクリップした質問に回答があった際、通知やメールを受け取ることができます。

    クリップを取り消します

  • 良い質問の評価を上げる

    以下のような質問は評価を上げましょう

    • 質問内容が明確
    • 自分も答えを知りたい
    • 質問者以外のユーザにも役立つ

    評価が高い質問は、TOPページの「注目」タブのフィードに表示されやすくなります。

    質問の評価を上げたことを取り消します

  • 評価を下げられる数の上限に達しました

    評価を下げることができません

    • 1日5回まで評価を下げられます
    • 1日に1ユーザに対して2回まで評価を下げられます

    質問の評価を下げる

    teratailでは下記のような質問を「具体的に困っていることがない質問」、「サイトポリシーに違反する質問」と定義し、推奨していません。

    • プログラミングに関係のない質問
    • やってほしいことだけを記載した丸投げの質問
    • 問題・課題が含まれていない質問
    • 意図的に内容が抹消された質問
    • 広告と受け取られるような投稿

    評価が下がると、TOPページの「アクティブ」「注目」タブのフィードに表示されにくくなります。

    質問の評価を下げたことを取り消します

    この機能は開放されていません

    評価を下げる条件を満たしてません

    評価を下げる理由を選択してください

    詳細な説明はこちら

    上記に当てはまらず、質問内容が明確になっていない質問には「情報の追加・修正依頼」機能からコメントをしてください。

    質問の評価を下げる機能の利用条件

    この機能を利用するためには、以下の事項を行う必要があります。

回答 1

checkベストアンサー

+1

zaifapi/zaifapi/api_common/response.pyを見てみるとHTTPステータス200以外ならZaifServerExceptionを投げているようなのでtryexceptで例外を捕捉して必要な再処理を行えばよいと思います。

while (True):
    # 略
    try:
        funds_btc = zaif_trade.get_info2()['funds']['btc']
        funds_jpy = zaif_trade.get_info2()['funds']['jpy']
    except ZaifServerException as e:
        # 何らかの再処理

投稿

  • 回答の評価を上げる

    以下のような回答は評価を上げましょう

    • 正しい回答
    • わかりやすい回答
    • ためになる回答

    評価が高い回答ほどページの上位に表示されます。

  • 回答の評価を下げる

    下記のような回答は推奨されていません。

    • 間違っている回答
    • 質問の回答になっていない投稿
    • スパムや攻撃的な表現を用いた投稿

    評価を下げる際はその理由を明確に伝え、適切な回答に修正してもらいましょう。

  • 2018/02/26 18:40

    whileのコードを変更して実行してみました。
    while (True):
    import datetime
    today = datetime.date.today()
    todaydetail = datetime.datetime.today()
    print("■ 現在の情報です:")
    print(todaydetail.strftime("%Y/%m/%d %H:%M:%S"))
    try:
    funds_btc = zaif_trade.get_info2()['funds']['btc']
    funds_jpy = zaif_trade.get_info2()['funds']['jpy']
    except ZaifServerException as e :
    last_price = int(zaif_public.last_price('btc_jpy')["last_price"])
    print("市場取引価格:"+str(last_price))
    print("btc資産:"+str(funds_btc))
    print("jpy資産:"+str(funds_jpy))
    print("最終取引価格:"+str(Last_trade_price))
    print(" ")
    【結果】
    確かにリトライするように動作は変わったようですが、最終的に502エラーで止まってしまいます。
    何が問題なのでしょうか。よろしくお願いいたします。

    c:\zaif>zaiftest02.py
    ■ 現在の情報です:
    2018/02/26 18:31:42
    ■ 現在の情報です:
    2018/02/26 18:32:23
    ■ 現在の情報です:
    2018/02/26 18:32:36
    ■ 現在の情報です:
    2018/02/26 18:32:46
    ■ 現在の情報です:
    2018/02/26 18:32:54
    ■ 現在の情報です:
    2018/02/26 18:33:09
    ■ 現在の情報です:
    2018/02/26 18:33:18
    ■ 現在の情報です:
    2018/02/26 18:33:27
    ■ 現在の情報です:
    2018/02/26 18:33:38
    ■ 現在の情報です:
    2018/02/26 18:33:46
    ■ 現在の情報です:
    2018/02/26 18:33:59
    ■ 現在の情報です:
    2018/02/26 18:34:08
    ■ 現在の情報です:
    2018/02/26 18:34:15
    ■ 現在の情報です:
    2018/02/26 18:34:35
    ■ 現在の情報です:
    2018/02/26 18:34:49
    ■ 現在の情報です:
    2018/02/26 18:34:56
    ■ 現在の情報です:
    2018/02/26 18:35:06
    Traceback (most recent call last):
    File "C:\zaif\zaiftest02.py", line 33, in <module>
    funds_btc = zaif_trade.get_info2()['funds']['btc']
    File "C:\Users\...\AppData\Local\Programs\Python\Python36-32\lib\site-packages\zaifapi\exchange_api\trade.py", line 70, in get_info2
    return self._execute_api(method_name())
    File "C:\Users\...\AppData\Local\Programs\Python\Python36-32\lib\site-packages\zaifapi\exchange_api\trade.py", line 33, in _execute_api
    res = get_response(url, params, header)
    File "C:\Users\...\AppData\Local\Programs\Python\Python36-32\lib\site-packages\zaifapi\api_common\response.py", line 9, in get_response
    raise ZaifServerException('return status code is {}'.format(response.status_code))
    zaifapi.api_error.ZaifServerException: return status code is 502

    キャンセル

  • 2018/02/26 18:46

    コード詳細が不明ですが、try~exceptの外側で例外が発生していませんか?

    キャンセル

  • 2018/02/26 19:08 編集

    try ~ except の位置がおかしいのに気が付きましたのでコードを変更しまして実行しました。
    【コード】
    while (True):
    import datetime
    today = datetime.date.today()
    todaydetail = datetime.datetime.today()
    print("■ 現在の情報です:")
    print(todaydetail.strftime("%Y/%m/%d %H:%M:%S"))
    try:
    funds_btc = zaif_trade.get_info2()['funds']['btc']
    funds_jpy = zaif_trade.get_info2()['funds']['jpy']
    last_price = int(zaif_public.last_price('btc_jpy')["last_price"])
    print("市場取引価格:"+str(last_price))
    print("btc資産:"+str(funds_btc))
    print("jpy資産:"+str(funds_jpy))
    print("最終取引価格:"+str(Last_trade_price))
    print(" ")
    except ZaifServerException as e:
    print("■ retry ■")

    【結果】
    NameError: name 'ZaifServerException' is not definedとなってしまいました。

    ■ 現在の情報です:
    2018/02/26 19:05:17
    市場取引価格:1016605
    btc資産:0.03865504
    jpy資産:149.18181063
    最終取引価格:1015390
     
    ■ 現在の情報です:
    2018/02/26 19:05:30
    Traceback (most recent call last):
    File "C:\zaif\zaiftest02.py", line 33, in <module>
    funds_btc = zaif_trade.get_info2()['funds']['btc']
    File "C:\Users\...\AppData\Local\Programs\Python\Python36-32\lib\site-packages\zaifapi\exchange_api\trade.py", line 70, in get_info2
    return self._execute_api(method_name())
    File "C:\Users\...\AppData\Local\Programs\Python\Python36-32\lib\site-packages\zaifapi\exchange_api\trade.py", line 33, in _execute_api
    res = get_response(url, params, header)
    File "C:\Users\...\AppData\Local\Programs\Python\Python36-32\lib\site-packages\zaifapi\api_common\response.py", line 9, in get_response
    raise ZaifServerException('return status code is {}'.format(response.status_code))
    zaifapi.api_error.ZaifServerException: return status code is 504

    During handling of the above exception, another exception occurred:

    Traceback (most recent call last):
    File "C:\zaif\zaiftest02.py", line 41, in <module>
    except ZaifServerException as e:
    NameError: name 'ZaifServerException' is not defined

    キャンセル

  • 2018/02/26 22:37

    importが必要ですね。
    from zaifapi.api_error import ZaifServerException

    キャンセル

15分調べてもわからないことは、teratailで質問しよう!

  • ただいまの回答率 90.45%
  • 質問をまとめることで、思考を整理して素早く解決
  • テンプレート機能で、簡単に質問をまとめられる

同じタグがついた質問を見る

  • Python 3.x

    10346questions

    Python 3はPythonプログラミング言語の最新バージョンであり、2008年12月3日にリリースされました。